//#include <stdio.h>
#include <math.h>       // pow()
/*#include <SDL.h>
#include <SDL_mixer.h>*/

//#define DISABLE_MIDI

#include "palmdep.h"

#include "qmus2mid.h"
#include "h2def.h"
#include "sounds.h"
#include "i_sound.h"
#include "timidity.h"

#include "pnobridge.h"

#define SHRT_MAX 32767
#define SHRT_MIN -32768

static int SAMPLECOUNT = 1024;
static int SAMPLESIZE = 2; //stereo-2, mono-1


// MWM 2000-01-08: Sample rate in samples/second
int snd_samplerate=22050;

static MidiSong *song;
static int paused_song;

int g_music_mode;

#include "SoundMgr.h"
static SndStreamRef snd_stream=NULL;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
int in_mix=0;
int loop_mode;



extern char *SavePath;
//Mix_Music *CurrentSong;
int SongPlaying;
int audio_opened;


#define SAMPLE_TYPE   int16


/*
 *
 *                           SOUND HEADER & DATA
 *
 *
 */

int tsm_ID = -1;

const char snd_prefixen[] = { 'P', 'P', 'A', 'S', 'S', 'S', 'M',
  'M', 'M', 'S' };

int snd_Channels;
int	snd_MaxVolume;      // maximum volume for sound
int	snd_MusicVolume;    // maximum volume for music


void I_UpdateSound(void *userdata, UInt8 *stream, int len);

static Err tim_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
	if (!in_mix){
		in_mix=1;		
		I_UpdateSound(NULL,bufferZ,frameCountZ);		
		in_mix=0;
	}
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}


void au_close(void)
{
	if (g_music_mode) Timidity_Close();
	
	stub_SndStreamStop(snd_stream);
	stub_SndStreamDelete(snd_stream);   	   	   	
}

int au_open(void){  	

#ifdef DISABLE_MIDI
	g_music_mode=0;
#endif
	if (g_music_mode){
	  	if (Timidity_Init(snd_samplerate,(SAMPLESIZE==2?AUDIO_S16LSB:AUDIO_S8),2,SAMPLECOUNT,"/PALM/Programs/Timidity/")){
    		menu_info("Error during Timidty Initialization");
    		g_music_mode=0;
	    }
	}
    
    /* PALM Stuff */  
	asm {
  		ldr  r0, = reg_sys
	  	add	 r0,r0,r10
  		str	 r9,[r0]
	  	str	 r10,[r0,#4]
    	}     
	stub_SndStreamCreate(&snd_stream,sndOutput,snd_samplerate,(SAMPLESIZE==2?sndInt16Little:sndInt8),sndStereo,tim_sndCallBack,&reg_sys,SAMPLECOUNT);
	stub_SndStreamStart(snd_stream);
    
   	SongPlaying=0;
  	audio_opened=1;

    return 1;
}

void I_PauseSong(int handle)
{
  paused_song=1;
}


void I_ResumeSong(int handle)
{
  paused_song=0;
}

void I_SetMusicVolume(int volume)
{
	snd_MusicVolume = volume;
    if (Timidity_Active()) Timidity_SetVolume(snd_MusicVolume*4);
}

void I_SetSfxVolume(int volume)
{
}

/*
 *
 *                              SONG API
 *
 */

int I_RegisterSong(void *data, int size)
{
  FILE *f;
  int sl;
  char *fn="tmp.mid";
  char *SongPath;
  
  if (!g_music_mode) return 0;

  if (SongPlaying) {
   I_StopSong(0);
//   SDL_Delay(20);
   I_UnRegisterSong(0);
  }

  sl=strlen(SavePath);
  SongPath=malloc(sl+strlen(fn)+1);
  strcpy(SongPath,SavePath);
  strcat(SongPath,fn);
  
  f=fopen(SongPath,"wb");
  if (!audio_opened) 
   au_open();
  if (f) {
   qmus2mid(data,size,f,1,0,0,0);
   fclose(f);
  
   song=Timidity_LoadSong("/PALM/Programs/ZHexen/tmp.mid");
   if (!song){
	    free(SongPath);
		I_Error("error at song loading");   				
		return 0;
   }
  }
  free(SongPath);
  return 1;

}

void I_UnRegisterSong(int handle)
{
  if (!song){  
  	//I_Error("I_UnregisterSong : no song!");
  	return;
  }    
//Sys_PrintF("I_UnregisterSong");  
  Timidity_FreeSongFTR(song,CREATORID);
  remove("tmp.mid");
  song=NULL;
/*   {
   		UInt32 bytes,max;
	   	MemHeapFreeBytes ( 0, &bytes, &max );
	   	sprintf(gpstr,"ram : %d/%d",bytes/1024,max/1024);
	   	menu_message(gpstr);
	}*/
  
}

int I_QrySongPlaying(int handle)
{
 return SongPlaying;
 /* XXX */
}

// Stops a song.  MUST be called before I_UnregisterSong().

void I_StopSong(int handle)
{
//  Mix_FadeOutMusic(500);
  SongPlaying=0;
  if (song) {
		Timidity_Stop();
		paused_song=2;		
  }
}


void I_PlaySong(int handle, boolean looping)
{
 if (SongPlaying) return;

 if (song) {
  	  Sys_PrintF2("Starting music...please wait");
/*  	  {
  		  UInt32 bytes,max;
	  	  MemHeapFreeBytes ( 0, &bytes, &max );
		  Sys_PrintF("free ram before: %d/%d",bytes>>10,max>>10);
		  menu_info(" ");
	  }*/
      Timidity_StartFTR(song,CREATORID,FTR_MIDI_START_ID);
      Timidity_SetVolume(snd_MusicVolume*4);
/*      {
  		  UInt32 bytes,max;
	  	  MemHeapFreeBytes ( 0, &bytes, &max );
		  Sys_PrintF("free ram after: %d/%d",bytes>>10,max>>10);
		  menu_info(" ");
	  }   */
  }
  paused_song=0;
  loop_mode=looping;

  SongPlaying=1;
}



/*
 *
 *                                 SOUND FX API
 *
 */


typedef struct
{
    unsigned char* begin;           // pointers into Sample.firstSample
    unsigned char* end;

    SAMPLE_TYPE* lvol_table;               // point into vol_lookup
    SAMPLE_TYPE* rvol_table;

    unsigned int pitch_step;
    unsigned int step_remainder;    // 0.16 bit remainder of last step.
    
    int pri;
    unsigned int time;
} Channel;


typedef struct
{
    short a;            // always 3
    short freq;         // always 11025
    long length;        // sample length
    unsigned char firstSample;
} Sample;


#define CHAN_COUNT        8
Channel schannel[ CHAN_COUNT];

#define MAX_VOL           128        // 64 keeps our table down to 16Kb
SAMPLE_TYPE vol_lookup[ MAX_VOL * 256 ];

int steptable[ 256 ];               // Pitch to stepping lookup


void I_UpdateSound(void *userdata, UInt8 *stream, int len)
{
    Channel* chan;
    Channel* cend;
    SAMPLE_TYPE*   leftout;
    SAMPLE_TYPE*   rightout;
    SAMPLE_TYPE*   leftend;
    int32 sample,dl,dr;
    int i;
    int       step;
       
    cend = schannel + CHAN_COUNT;
    
    
    if (song&&loop_mode&&!paused_song)
  	if (!Timidity_Active()) Timidity_ReStart(song);
  
    if (song&&!paused_song&&Timidity_Active()) Timidity_PlaySome(stream,len);
    else for (i=0;i<len*2;i++) ((UInt16*)stream)[i]=0;
    
    // Left and right channel
    //  are in audio stream, alternating.
    leftout = (signed short *)stream;
    rightout = ((signed short *)stream)+1;
    step = 2;

    // Determine end, for left channel only
    //  (right channel is implicit).
    leftend = leftout + (len)*step;

    // Mix sounds into the mixing buffer.
    // Loop over step*SAMPLECOUNT,
    //  that is 512 values for two channels.
    while (leftout != leftend) {
            // Mix all the channels together.

            dl = *leftout;
  // zero sample 
            dr = *rightout;
            chan = schannel;
            for( ; chan < cend; chan++ )
            {
                // Check channel, if active.
                if( chan->begin )
                {
                    // Get the sample from the channel. 
                    sample = *chan->begin;

                    // Adjust volume accordingly.
                    dl += chan->lvol_table[ sample ];
                    dr += chan->rvol_table[ sample ];

                    // Increment sample pointer with pitch adjustment.
                    chan->step_remainder += chan->pitch_step;
                    chan->begin += chan->step_remainder >> 16;
                    chan->step_remainder &= 65535;

                    // Check whether we are done.
                    if( chan->begin >= chan->end )
                    {
                        chan->begin = 0;
                    }
                }
            }
            
    if (dl > SHRT_MAX)
      *leftout = SHRT_MAX;
    else if (dl < SHRT_MIN)
      *leftout = SHRT_MIN;
    else
      *leftout = (signed short)dl;

    // Same for right hardware channel.
    if (dr > SHRT_MAX)
      *rightout = SHRT_MAX;
    else if (dr < SHRT_MIN)
      *rightout = SHRT_MIN;
    else
      *rightout = (signed short)dr;

    // Increment current pointers in stream
    leftout += step;
    rightout += step;
        }
  
}


// Gets lump nums of the named sound.  Returns pointer which will be
// passed to I_StartSound() when you want to start an SFX.  Must be
// sure to pass this to UngetSoundEffect() so that they can be
// freed!


int I_GetSfxLumpNum(sfxinfo_t *sound)
{
  return W_GetNumForName(sound->lumpname);
}


// Id is unused.
// Data is a pointer to a Sample structure.
// Volume ranges from 0 to 127.
// Separation (orientation/stereo) ranges from 0 to 255.  128 is balanced.
// Pitch ranges from 0 to 255.  Normal is 128.
// Priority looks to be unused (always 0).

int I_StartSound( int id, void* data, int vol, int sep, int pitch, int priority)
{
    // Relative time order to find oldest sound.
    static unsigned int soundTime = 0;
    int chanId;
    Sample* sample;
    Channel* chan;
    int oldest;
    int i;
    // Find an empty channel, the oldest playing channel, or default to 0.
    // Currently ignoring priority.

    chanId = 0;
    oldest = soundTime;
    for( i = 0; i < CHAN_COUNT; i++ )
    {
        if( ! schannel[ i ].begin )
        {
            chanId = i;
            break;
        }
        if( schannel[ i ].time < oldest )
        {
            chanId = i;
            oldest = schannel[ i ].time;
        }
    }

    sample = (Sample*) data;
    chan = &schannel[ chanId ];

    I_UpdateSoundParams( chanId + 1, vol, sep, pitch );

    chan->pri = priority;
    chan->time = soundTime;
    chan->end = &sample->firstSample + sample->length;
    chan->begin = &sample->firstSample;

    soundTime++;

    return chanId + 1;
}

void I_StopSound(int handle)
{
    handle--;
    handle &= 7;
    schannel[ handle ].begin = 0;
}

int I_SoundIsPlaying(int handle)
{
    handle--;
    handle &= 7;
    return( schannel[ handle ].begin != 0 );
}

void I_UpdateSoundParams(int handle, int vol, int sep, int pitch)
{
    int lvol, rvol;
    Channel* chan;

    // Set left/right channel volume based on seperation.

    sep += 1;       // range 1 - 256
    lvol = vol - ((vol * sep * sep) >> 16); // (256*256);
    sep = sep - 257;
    rvol = vol - ((vol * sep * sep) >> 16);    


    // Sanity check, clamp volume.
    if( rvol < 0 )
    {
        //printf( "rvol out of bounds %d, id %d\n", rvol, handle );
        rvol = 0;
    }
    else if( rvol > 127 )
    {
        //printf( "rvol out of bounds %d, id %d\n", rvol, handle );
        rvol = 127;
    }
    
    if( lvol < 0 )
    {
        //printf( "lvol out of bounds %d, id %d\n", lvol, handle );
        lvol = 0;
    }
    else if( lvol > 127 )
    {
        //printf( "lvol out of bounds %d, id %d\n", lvol, handle );
        lvol = 127;
    }

    handle--;
    handle &= 7;
    chan = &schannel[ handle ];
    chan->pitch_step = steptable[ pitch ];
    chan->step_remainder = 0;
    chan->lvol_table = &vol_lookup[ lvol * 256 ];
    chan->rvol_table = &vol_lookup[ rvol * 256 ];
}

/*
 *
 *                                                      SOUND STARTUP STUFF
 *
 *
 */

// inits all sound stuff



void I_StartupSound (void)
{
    int ok;

//    snd_MusicDevice = snd_SfxDevice = 0;

    if( M_CheckParm( "-nosound" ) )
    {
        ST_Message("I_StartupSound: Sound Disabled.\n");
        return;
    }

    if (debugmode)
        ST_Message("I_StartupSound: Hope you hear a pop.\n");

    if (!audio_opened)
     ok = au_open();
    
}

// shuts down all sound stuff

void I_ShutdownSound (void)
{
	I_StopSong(0);
	I_UnRegisterSong(0);
		
    au_close();
}

void I_SetChannels(int channels)
{
    int v, j,i;
    int* steptablemid;

    // We always have CHAN_COUNT channels.

    for( j = 0; j < CHAN_COUNT; j++ )
    {
        schannel[ j ].begin = 0;
        schannel[ j ].end = 0;
        schannel[ j ].time = 0;
    }


    // This table provides step widths for pitch parameters.
    steptablemid = steptable + 128;
    for (i=-128 ; i<128 ; i++)
    	steptablemid[i] = (int)(pow(1.2, ((double)i/(64.0*snd_samplerate/11025)))*65536.0);


    // Generate the volume lookup tables.
     for (i=0 ; i<128 ; i++)
    for (j=0 ; j<256 ; j++)
    {
      // proff - made this a little bit softer, because with
      // full volume the sound clipped badly
      vol_lookup[i*256+j] = (i*(j-128)*256)/191;
      //vol_lookup[i*256+j] = (i*(j-128)*256)/127;
    }
}


/* EOF */
