#define __STACK_SIZE__ 256*1024//256*1024

#include "math.h"

#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

#include "AppRsc.h"

#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif

// conveniance pointers
UInt32 display_pitch,display_height,display_width;
UInt32 device_type;
UInt32 ticks_per_sec;
UInt32 currentOwnerID;


#define PNO_Main ARMlet_Main

Call68KFuncType * g_my_call68KFuncP;
const void *g_my_emulStateP;
pnobridge_t *g_pnobridge;


#ifdef __PACE__  
UInt32 TimGetTicks ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA0F7 & (0x00000FFF)), 0, 0)));
}

UInt16 SysTicksPerSecond ( void ) {
  return (( UInt16)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2E9 & (0x00000FFF)), 0, 0)));
}

UInt32 KeyCurrentState ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2A2 & (0x00000FFF)), 0, 0)));
}
#endif

Int32 GetTickCount()
{
	Int32 l=TimGetTicks();
	return l*1000/ticks_per_sec;
}

// ------------------------

uint32 my_stack,my_stackal,old_stack;
  unsigned long pno_result;
  
asm uint32 swap_stack(uint32 new ,uint32 dummy)
{	
	mov  r1,r13
	mov  r13,r0
	mov	 r0,r1
	bx	 lr
}

unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP);


SysAppInfoPtr SysGetAppInfo(SysAppInfoPtr *uiAppPP, SysAppInfoPtr *actionCodeAppPP);


unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP)
{
 // needed before making any OS calls using the 
  // PACEInterface library
#ifdef __PACE__  
  InitPACEInterface ( emulStateP, call68KFuncP );
#endif  

  // my cheap hack to get StrAToI happy without modifying paceinterfacelib
  g_my_call68KFuncP = call68KFuncP;
  g_my_emulStateP = emulStateP;
  g_pnobridge = userData68KP;
  

  SysAppInfoPtr appInfoP,unusedAppInfoP; 
  currentOwnerID = SysGetAppInfo(&unusedAppInfoP, & appInfoP)->memOwnerID; 


  g_pnobridge -> vram = ByteSwap32 ( g_pnobridge -> vram );
  g_pnobridge -> eventf = ByteSwap32 ( g_pnobridge -> eventf );
  g_pnobridge -> display_width = ByteSwap32 ( g_pnobridge -> display_width );
  g_pnobridge -> display_height = ByteSwap32 ( g_pnobridge -> display_height );
  g_pnobridge -> display_pitch = ByteSwap32 ( g_pnobridge -> display_pitch );
  g_pnobridge -> param1 = ByteSwap32 ( g_pnobridge -> param1 );
  g_pnobridge -> param2 = ByteSwap32 ( g_pnobridge -> param2 );
  g_pnobridge -> flags = ByteSwap32 ( g_pnobridge -> flags );

  display_pitch = g_pnobridge -> display_pitch;
  display_width = g_pnobridge -> display_width;
  display_height = g_pnobridge -> display_height;
  
  device_type = g_pnobridge -> flags & (BF_ZODIAC|BF_HIRESPLUS);
  
  ticks_per_sec = SysTicksPerSecond();
  
/*  if ( g_pnobridge -> flags  & BF_ZODIAC )
    {
    	//get backbuffer
    	(unsigned char *) (UInt16*) stubzodiacblit ( 1 );
    }*/
  
  /*new stack*/
  
  my_stack=(uint32)malloc(__STACK_SIZE__+8);
  my_stackal=my_stack+__STACK_SIZE__;
  my_stackal-=my_stackal&7;

  old_stack=swap_stack(my_stackal,0);
  

  pno_result=Run();

  swap_stack(old_stack,0);

  free((void*)my_stack);

  return pno_result;
}


void *MemGluePtrNewL ( UInt32 foo ) {
  UInt32 r;
  UInt32 arg[2];

	arg[0] = BRIDGE_MemGluePtrNew;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(foo);
	arg[1] = ByteSwap32 ( arg[1] );
  r = g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &arg, 8 );

  return ( (UInt8*) r );
}



void stub_fullscreen(int fs){
	UInt32 arg[2];
	arg[0] = BRIDGE_Fullscreen;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(fs);
	arg[1] = ByteSwap32 ( arg[1] );
	g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );	
}

void stub_consoleCmd(char *cmd){
	UInt32 arg[2];
	arg[0] = BRIDGE_consoleCmd;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(cmd);
	arg[1] = ByteSwap32 ( arg[1] );
	g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );	
}

signed long long fixed_sqrt (signed long long val)
{
	signed long long xr;      // result register 
    signed long long q2;      // scan-bit register 
    int f;                 // flag (one bit) 

        xr = 0;                         // clear result 
        q2 = 0x4000000000000000;               // higest possible result bit 
        do
        {
          if((xr + q2) <= val)
          {
            val -= xr + q2;
            f = 1;                      // set flag 
          }
          else f = 0;                   // clear flag 
          xr >>= 1;
          if(f) xr += q2;               // test flag 
        } while(q2 >>= 2);              // shift twice 

        return xr;
}



Err stub_SndStreamCreate(SndStreamRef *channel,	/* channel-ID is stored here */
						SndStreamMode mode,			/* input/output, enum */
						UInt32 samplerate,				/* in frames/second, e.g. 44100, 48000 */
						SndSampleType type,				/* enum, e.g. sndInt16 */
						SndStreamWidth width,			/* enum, e.g. sndMono */
						SndStreamBufferCallback func,	/* function that gets called to fill a buffer */
						void *userdata,					/* gets passed in to the above function */
						UInt32 buffsize){				/* preferred buffersize in frames, not guaranteed, use 0 for default */

	bighostcall_t data;
	Err r;
	UInt32 arg[2];

	data.a=ByteSwap32((UInt32)channel);
	data.b=ByteSwap32((UInt32)mode);
	data.c=ByteSwap32((UInt32)samplerate);
	data.d=ByteSwap32((UInt32)type);
	data.e=ByteSwap32((UInt32)width);	
	data.f=ByteSwap32((UInt32)func);	
	data.g=ByteSwap32((UInt32)userdata);	
	data.h=ByteSwap32((UInt32)buffsize);	
	data.i=ByteSwap32((UInt32)1/*armNative*/);	
	
	
	arg[0] = BRIDGE_SndStreamCreate;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );

	r=g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
	*channel = (SndStreamRef)ByteSwap32((UInt32)(*channel));
	return r;
}							

Err stub_SndStreamDelete(SndStreamRef channel){
	UInt32 arg[2];
	arg[0] = BRIDGE_SndStreamDelete;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(channel);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamStart(SndStreamRef channel){
	UInt32 arg[2];
	arg[0] = BRIDGE_SndStreamStart;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(channel);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamStop(SndStreamRef channel){
	UInt32 arg[2];
	arg[0] = BRIDGE_SndStreamStop;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(channel);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamSetVolume(SndStreamRef channel, Int32 volume){
	UInt32 arg[2];
	hostcall_t data;	
	data.a=ByteSwap32((UInt32)channel);
	data.b=ByteSwap32((UInt32)volume);	
	arg[0] = BRIDGE_SndStreamSetVolume;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamGetVolume(SndStreamRef channel, Int32 *volume){
	Int32 arg[2];
	Err r;
	hostcall_t data;	
	data.a=ByteSwap32((UInt32)channel);
	data.b=ByteSwap32((UInt32)volume);
	arg[0] = BRIDGE_SndStreamGetVolume;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	r=g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
	*volume=ByteSwap32((UInt32)(*volume));
	return r;
}

// 0 == lock; 1 == unlock; 2 == blit; 3 == scaled blit with optionnal smooth (s)
UInt32 stubzodiacblit ( UInt32 mode, UInt32 w,UInt32 h,UInt32 s ) {
  Int32 arg[2];
  hostcall_t data;	
  UInt32 ret;
  
  data.a=ByteSwap32(mode);
  data.b=ByteSwap32(w);
  data.c=ByteSwap32(h);
  data.d=ByteSwap32(s);
  arg[0] = BRIDGE_zodiacblit;
  arg[0] = ByteSwap32 ( arg[0] );
  arg[1] = (UInt32)(&data);
  arg[1] = ByteSwap32 ( arg[1] );
	
  ret = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 8 );

  return ( ret );
}